
_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 13
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ATmega644P_OOP.c,5 :: 		void main() {
;ATmega644P_OOP.c,11 :: 		MM_Init();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _MM_Init+0
;ATmega644P_OOP.c,13 :: 		sensor1 = (Sensor*)Malloc(1 * sizeof(Sensor));
	LDI        R27, 8
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _Malloc+0
	STD        Y+0, R16
	STD        Y+1, R17
;ATmega644P_OOP.c,14 :: 		(*sensor1).name = "ADS1015";
	MOVW       R30, R16
	ADIW       R30, 4
	LDI        R27, #lo_addr(?lstr1_ATmega644P_OOP+0)
	ST         Z+, R27
	LDI        R27, hi_addr(?lstr1_ATmega644P_OOP+0)
	ST         Z+, R27
;ATmega644P_OOP.c,15 :: 		(*sensor1).super.read = &sensorRead;
	LDD        R30, Y+0
	LDD        R31, Y+1
	LDI        R27, #lo_addr(_sensorRead+0)
	ST         Z+, R27
	LDI        R27, hi_addr(_sensorRead+0)
	ST         Z+, R27
;ATmega644P_OOP.c,16 :: 		(*sensor1).super.write = &sensorWrite;
	LDD        R16, Y+0
	LDD        R17, Y+1
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, #lo_addr(_sensorWrite+0)
	ST         Z+, R27
	LDI        R27, hi_addr(_sensorWrite+0)
	ST         Z+, R27
;ATmega644P_OOP.c,18 :: 		eeprom1 = (EEPROM*)Malloc(1 * sizeof(EEPROM));
	LDI        R27, 8
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _Malloc+0
	STD        Y+2, R16
	STD        Y+3, R17
;ATmega644P_OOP.c,19 :: 		(*eeprom1).name = "24C256";
	MOVW       R30, R16
	ADIW       R30, 4
	LDI        R27, #lo_addr(?lstr2_ATmega644P_OOP+0)
	ST         Z+, R27
	LDI        R27, hi_addr(?lstr2_ATmega644P_OOP+0)
	ST         Z+, R27
;ATmega644P_OOP.c,20 :: 		(*eeprom1).super.read = &eepromRead;
	LDD        R30, Y+2
	LDD        R31, Y+3
	LDI        R27, #lo_addr(_eepromRead+0)
	ST         Z+, R27
	LDI        R27, hi_addr(_eepromRead+0)
	ST         Z+, R27
;ATmega644P_OOP.c,21 :: 		(*eeprom1).super.write = &eepromWrite; // & is optional
	LDD        R16, Y+2
	LDD        R17, Y+3
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, #lo_addr(_eepromWrite+0)
	ST         Z+, R27
	LDI        R27, hi_addr(_eepromWrite+0)
	ST         Z+, R27
;ATmega644P_OOP.c,23 :: 		UART1_Init(9600);
	LDI        R27, 129
	STS        UBRR0L+0, R27
	LDI        R27, 0
	STS        UBRR0H+0, R27
	CALL       _UART1_Init+0
;ATmega644P_OOP.c,24 :: 		TWI_Init(100000);
	LDS        R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	STS        TWPS0_bit+0, R27
	LDS        R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	STS        TWPS1_bit+0, R27
	LDI        R27, 92
	STS        TWBR+0, R27
	CALL       _TWI_Init+0
;ATmega644P_OOP.c,29 :: 		UART1_Write_Text((*sensor1).name); nl();
	LDD        R16, Y+0
	LDD        R17, Y+1
	MOVW       R30, R16
	ADIW       R30, 4
	LD         R16, Z+
	LD         R17, Z+
	MOVW       R2, R16
	CALL       _UART1_Write_Text+0
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATmega644P_OOP.c,31 :: 		for (i = 0; i < 2; i++) {
	LDI        R27, 0
	STD        Y+4, R27
	STD        Y+5, R27
L_main0:
	LDD        R18, Y+4
	LDD        R19, Y+5
	LDI        R16, 2
	LDI        R17, 0
	CP         R18, R16
	CPC        R19, R17
	BRLT       L__main10
	JMP        L_main1
L__main10:
;ATmega644P_OOP.c,32 :: 		receive(sensor1);
	LDD        R30, Y+0
	LDD        R31, Y+1
	LD         R16, Z+
	LD         R17, Z+
	LDD        R2, Y+0
	LDD        R3, Y+1
	MOVW       R30, R16
	ICALL
;ATmega644P_OOP.c,33 :: 		UART1_Write_Text((*sensor1).value); nl();
	LDD        R16, Y+0
	LDD        R17, Y+1
	MOVW       R30, R16
	ADIW       R30, 6
	LD         R16, Z+
	LD         R17, Z+
	MOVW       R2, R16
	CALL       _UART1_Write_Text+0
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATmega644P_OOP.c,34 :: 		Delay_ms(250);
	LDI        R18, 26
	LDI        R17, 94
	LDI        R16, 111
L_main3:
	DEC        R16
	BRNE       L_main3
	DEC        R17
	BRNE       L_main3
	DEC        R18
	BRNE       L_main3
	NOP
;ATmega644P_OOP.c,31 :: 		for (i = 0; i < 2; i++) {
	LDD        R16, Y+4
	LDD        R17, Y+5
	SUBI       R16, 255
	SBCI       R17, 255
	STD        Y+4, R16
	STD        Y+5, R17
;ATmega644P_OOP.c,35 :: 		}//for_i
	JMP        L_main0
L_main1:
;ATmega644P_OOP.c,37 :: 		nl(); UART1_Write_Text((*eeprom1).name); nl();
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDD        R16, Y+2
	LDD        R17, Y+3
	MOVW       R30, R16
	ADIW       R30, 4
	LD         R16, Z+
	LD         R17, Z+
	MOVW       R2, R16
	CALL       _UART1_Write_Text+0
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATmega644P_OOP.c,38 :: 		IntToHex(eeprom1, address);
	MOVW       R16, R28
	SUBI       R16, 250
	SBCI       R17, 255
	MOVW       R4, R16
	LDD        R2, Y+2
	LDD        R3, Y+3
	CALL       _IntToHex+0
;ATmega644P_OOP.c,39 :: 		UART1_Write_Text("E2prom address "); UART1_Write_Text(address); nl();
	LDI        R27, #lo_addr(?lstr3_ATmega644P_OOP+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr3_ATmega644P_OOP+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
	MOVW       R16, R28
	SUBI       R16, 250
	SBCI       R17, 255
	MOVW       R2, R16
	CALL       _UART1_Write_Text+0
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATmega644P_OOP.c,41 :: 		send(eeprom1);
	LDD        R16, Y+2
	LDD        R17, Y+3
	MOVW       R30, R16
	ADIW       R30, 2
	LD         R16, Z+
	LD         R17, Z+
	LDD        R2, Y+2
	LDD        R3, Y+3
	MOVW       R30, R16
	ICALL
;ATmega644P_OOP.c,44 :: 		Delay_ms(10);
	LDI        R18, 2
	LDI        R17, 4
	LDI        R16, 187
L_main5:
	DEC        R16
	BRNE       L_main5
	DEC        R17
	BRNE       L_main5
	DEC        R18
	BRNE       L_main5
	NOP
;ATmega644P_OOP.c,47 :: 		receive(eeprom1);
	LDD        R30, Y+2
	LDD        R31, Y+3
	LD         R16, Z+
	LD         R17, Z+
	LDD        R2, Y+2
	LDD        R3, Y+3
	MOVW       R30, R16
	ICALL
;ATmega644P_OOP.c,48 :: 		UART1_Write_Text((*eeprom1).value); nl();
	LDD        R16, Y+2
	LDD        R17, Y+3
	MOVW       R30, R16
	ADIW       R30, 6
	LD         R16, Z+
	LD         R17, Z+
	MOVW       R2, R16
	CALL       _UART1_Write_Text+0
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATmega644P_OOP.c,50 :: 		TWI_Close();
	CALL       _TWI_Close+0
;ATmega644P_OOP.c,52 :: 		Free((char*)sensor1, sizeof(sensor1));
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, 0
	MOV        R5, R27
	LDD        R2, Y+0
	LDD        R3, Y+1
	CALL       _Free+0
;ATmega644P_OOP.c,53 :: 		Free((char*)eeprom1, sizeof(eeprom1));
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, 0
	MOV        R5, R27
	LDD        R2, Y+2
	LDD        R3, Y+3
	CALL       _Free+0
;ATmega644P_OOP.c,55 :: 		while(1); // eternity
L_main7:
	JMP        L_main7
;ATmega644P_OOP.c,57 :: 		} // main
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
