#line 1 "C:/Users/Temelko/Desktop/ATmega644P_OOP/source/ATmega644P_OOP.c"
#line 1 "c:/users/temelko/desktop/atmega644p_oop/source/defs.h"



typedef struct superior {
 char *(*read)(struct superior*);
 void (*write)(struct superior*);
} TWI;

typedef struct inferior1 {
 TWI super;
 char *name, *value;
} Sensor;

typedef struct inferior2 {
 TWI super;
 char *name, *value;
} Eeprom;

char *sensorRead(TWI *me);
void sensorWrite(TWI *me);
char *eepromRead(TWI *me);
void eepromWrite(TWI *me);
#line 3 "C:/Users/Temelko/Desktop/ATmega644P_OOP/source/ATmega644P_OOP.c"
const unsigned int HEAP_SIZE = 80;

void main() {
Sensor *sensor1;
Eeprom *eeprom1;
int i;
char address[7];

 MM_Init();

 sensor1 = (Sensor*)Malloc(1 * sizeof(Sensor));
 (*sensor1).name = "ADS1015";
 (*sensor1).super.read = &sensorRead;
 (*sensor1).super.write = &sensorWrite;

 eeprom1 = (EEPROM*)Malloc(1 * sizeof(EEPROM));
 (*eeprom1).name = "24C256";
 (*eeprom1).super.read = &eepromRead;
 (*eeprom1).super.write = &eepromWrite;

 UART1_Init(9600);
 TWI_Init(100000);




 UART1_Write_Text((*sensor1).name);  UART1_Write(13); UART1_Write(10); ;

 for (i = 0; i < 2; i++) {
  sensor1->super.read(&sensor1->super); ;
 UART1_Write_Text((*sensor1).value);  UART1_Write(13); UART1_Write(10); ;
 Delay_ms(250);
 }

  UART1_Write(13); UART1_Write(10); ; UART1_Write_Text((*eeprom1).name);  UART1_Write(13); UART1_Write(10); ;
 IntToHex(eeprom1, address);
 UART1_Write_Text("E2prom address "); UART1_Write_Text(address);  UART1_Write(13); UART1_Write(10); ;

  eeprom1->super.write(&eeprom1->super); ;


 Delay_ms(10);


  eeprom1->super.read(&eeprom1->super); ;
 UART1_Write_Text((*eeprom1).value);  UART1_Write(13); UART1_Write(10); ;

 TWI_Close();

 Free((char*)sensor1, sizeof(sensor1));
 Free((char*)eeprom1, sizeof(eeprom1));

 while(1);

}
