#line 1 "C:/Users/Temelko/Desktop/ATmega644P_OOP/source/defs.c"
#line 1 "c:/users/temelko/desktop/atmega644p_oop/source/defs.h"



typedef struct superior {
 char *(*read)(struct superior*);
 void (*write)(struct superior*);
} TWI;

typedef struct inferior1 {
 TWI super;
 char *name, *value;
} Sensor;

typedef struct inferior2 {
 TWI super;
 char *name, *value;
} Eeprom;

char *sensorRead(TWI *me);
void sensorWrite(TWI *me);
char *eepromRead(TWI *me);
void eepromWrite(TWI *me);
#line 3 "C:/Users/Temelko/Desktop/ATmega644P_OOP/source/defs.c"
char *sensorRead(TWI *me) {
Sensor *me_ = (Sensor*)me;
static char datumS[16];
int res;
unsigned int config =  (0x0003)  |
  (0x0000)  |
  (0x0000)  |
  (0x0000)  |
  (0x0080)  |
  (0x0100)  |
  (0x0200)  |
  (0x4000)  |
  (0x8000) ;

 TWI_Start();
 TWI_Write( 0b10010000 );
 TWI_Write(0x01);
 TWI_Write(config >> 8);
 TWI_Write(config & 0xFF);
 TWI_Stop();



 TWI_Start();
 TWI_Write( 0b10010000 );
 TWI_Write(0x00);
 TWI_Stop();
 TWI_Start();
 TWI_Write( 0b10010000  | 0x01);
 res = TWI_Read(1) << 8;
 res |= TWI_Read(0);
 TWI_Stop();

 res >>= 4;
 IntToStr(res, datumS);
 (*me_).value = datumS;

 return '0';
}

void sensorWrite(TWI *me) { return; }

char *eepromRead(TWI *me) {
Eeprom *me_ = (Eeprom*)me;
static char datumE[16];
int res;

 TWI_Start();
 TWI_Write( 0b10100000 );
 TWI_Write(0x23);
 TWI_Write(0x23);
 TWI_Start();
 TWI_Write( 0b10100000  | 0x01);
 res = TWI_Read(0);
 TWI_Stop();

 IntToStr(res, datumE);
 (*me_).value = datumE;

 return '0';
}

void eepromWrite(TWI *me) {
Eeprom *me_ = (Eeprom*)me;

 TWI_Start();
 TWI_Write( 0b10100000 );
 TWI_Write(0x23);
 TWI_Write(0x23);
 TWI_Write(0x4B);
 TWI_Stop();

 return;
}
